cd 'd:\wwg\855\ass2'

# Question 2 : Plot Autocorrelation Function
set terminal png
set title "Autocorrelation Function"
set xlabel "lag k"
set ylabel "Autocorrelation Coefficient"
#set format y "%g%%"
set nologscale y
set nologscale x
set output "q2.png"
plot [0:200] [-1:1] "autocorr.dat" title "Autocorrelation Function" with lines, 0 with lines 1

# Question 3 : Plot Variance-Time Plot
set terminal png 
set title "Variance-Time Plot"
set xlabel "Block Size"
set ylabel "Variance"
set logscale y
set logscale x
#set format y "%4.1f"
set output "q3.png"
plot [] [10:1e9] "variance.dat" title "Variance-Time Plot", 2.5e7 t "Slope = 0" with lines, 2.5e+7/x t "Slope = -1" with lines, 2.5e7*x**(-0.2) t "Slope = -0.2" with lines lt 1

# Question 4 : Plot R/S Pox Diagram
set terminal png
# set terminal windows
set title "R/S Pox Diagram"
set xlabel "Block Size n"
set ylabel "R/S Statistic"
set logscale y
set logscale x
#set format y "%4.1f"
set output "q4.png"
plot [1:] "rs.dat" title "R/S Pox Diagram" with points, sqrt(x)*0.45 t "Slope 0.5" with lines, 0.45*x t "Slope 1.0" with lines, 0.45*(x**0.85) t "Slope 0.85" with lines lt 1

# Question 5: CLR Plot

set terminal png
set title "Cell Loss Ratio versus Link Capacity"
set xlabel "Link Capacity (cells/second)"
set ylabel "Cell Loss Ratio"
set logscale y
set nologscale x
set format y "%f"
set ytics (0.000001,0.00001,0.0001,0.001,0.01,0.1,1)
set output "q5.png"
plot [0:] [0.000001:1.0] \
    "100.dat"    t "buffer size :     100 cells" w lines, \
    "400.dat"    t "buffer size :     400 cells" w lines, \
    "1600.dat"   t "buffer size :   1,600 cells" with lines, \
    "6400.dat"   t "buffer size :   6,400 cells" with lines, \
    "25600.dat"  t "buffer size :  25,600 cells" with lines, \
    "100000.dat" t "buffer size : 100,000 cells" w lines

#"1000.dat" title "buffer size : 1000 cells" with lines,"4000.dat" title "buffer size : 4000 cells" with lines,"12000.dat" title "buffer size : 12000 cells" with lines

# discussion
set terminal png
set title "Cell/Packet Loss Ratio versus Buffer Size"
set xlabel "Buffer Size (cells)"
set ylabel "Loss Ratio"
set logscale y
set nologscale x
set ytics
set key
#set key 50000,0.007
set format y "%5.3f"
set output "q6.png"
plot [100:] [] \
    "c4000.txt"   t "CLR, C= 4000 cells/s" w linesp, \
    "cp4000.txt"   t "PLR, C= 4000 cells/s" w linesp, \
    "c8000.txt"   t "CLR, C= 8000 cells/s" w linesp, \
    "cp8000.txt"   t "PLR, C= 8000 cells/s" w linesp

set nologscale y
set logscale x
set key 58000,0.43
set output "q7.png"
set ytics 0,0.1,0.6
set format y "%3.1f"
plot [100:] [0:0.6] \
    "c500.txt"    t "CLR, C=  500 cells/s" w linesp, \
    "cp500.txt"    t "PLR, C=  500 cells/s" w linesp, \
    "c1000.txt"   t "CLR, C= 1000 cells/s" w linesp, \
    "cp1000.txt"   t "PLR, C= 1000 cells/s" w linesp, \
    "c2000.txt"   t "CLR, C= 2000 cells/s" w linesp, \
    "cp2000.txt"   t "PLR, C= 2000 cells/s" w linesp

set terminal png
set title "Demo of CLR vs. Buffer size in linear scale"
set xlabel "Buffer Size (cells)"
set ylabel "Cell Loss Ratio"
set nologscale y
set nologscale x
set ytics 0,0.2,1
set xtics 0,20,100
set output "q8.png"
plot [0:100][0:1] 1/x

set terminal png
set output "temp.png"
set nologscale x
set nologscale y
plot sin(x)
quit

