int compare( const void *arg1, const void *arg2 )
{
  // sort by reverse order
  return *((int*)arg2) - *((int*)arg1);
}

class Q2
{
public:
  FILE *f1, *f2;
  int maxhost;
  int *pkg_freq;
  int pkg_num;
  Q2()
  {
    int i;
    maxhost=1289;
    pkg_num = 0;
    pkg_freq = new int[maxhost];
    f1=fopen("q2p.txt","wt");
    f2=fopen("q2c.txt","wt");
    if (!f1 || !f2)
    {
        printf("Cannot create file\n");
        return;
    }
    for (i=0; i<maxhost; i++)
      pkg_freq[i] = 0;
  };

  ~Q2()
  {
    int i;

    // sort result
    qsort(pkg_freq,maxhost,sizeof(int),compare);

    // get the number of distinct hosts
    while (pkg_freq[maxhost-1]==0)
      maxhost--;

    // output result
    for (i=0; i<maxhost; i++)
      fprintf(f1,"%d\t%lf\n",i+1,double(pkg_freq[i])/pkg_num);

    // compute accumulative num
    for (i=1; i<maxhost; i++)
      pkg_freq[i] += pkg_freq[i-1];

    // output result
    for (i=0; i<maxhost; i++)
      fprintf(f2,"%d\t%lf\n",i+1,double(pkg_freq[i])/pkg_num);

    delete pkg_freq;
    fclose(f1);
    fclose(f2);
  };

  void process_one(double time, int host, int size)
  {
    pkg_num++;
    pkg_freq[host]++;
  };
};
