#include <stdio.h>
#include <math.h>

#define NUMBER 6
#define PCRNUMBER 6
#define FRAMENUMBER 171000
main()
{
  FILE *inputfp,*outputfp,*bufferfp,*clrfp,*flrfp;
  int cellsize;
  int totalbuffersize,freebuffersize;
  int pcr40,pcr;
  int totalframe, totalcell;
  int lostframe,lostcell;
  double clr,flr;
  int i;
  int count;
  int j,k;
  int n;
  char filename[50];
  const int buffer[NUMBER]={1600,2000,4000,8000,16000,32000};
  const int pcrrate40[PCRNUMBER]={600,800,1000,1100,1150,1200};
  /*const int pcrrate40[PCRNUMBER]={600,650,700,750,800,850,900,950,1000,1050,1100,1150,1200,1250};*/
  double clrarray[NUMBER][PCRNUMBER];
  double flrarray[NUMBER][PCRNUMBER];
  int framearray[FRAMENUMBER];
  
  
  inputfp=fopen("cellsize.txt","r");
  if(inputfp==NULL){
    fprintf(stderr,"can not open the file\n");
    exit(1);
  }
  
  n=0;
  while(fscanf(inputfp,"%d",&cellsize)!=EOF)
  {
     framearray[n]=cellsize;
     n++;
  }
  fclose(inputfp);
  
  outputfp=fopen("clrresult.txt","w");
  if(outputfp==NULL){
    fprintf(stderr,"can not open the file\n");
    exit(1);
  }
  clrfp=fopen("clrrep.txt","w");
  if(clrfp==NULL){
    fprintf(stderr,"can not open the file\n");
    exit(1);
  }
  for(i=0;i<PCRNUMBER;i++)
  {
    fprintf(clrfp,"          R%d",pcrrate40[i]);
  }
  fprintf(clrfp,"\n");
  flrfp=fopen("flrrep.txt","w");
  if(flrfp==NULL){
    fprintf(stderr,"can not open the file\n");
    exit(1);
  }
    for(i=0;i<PCRNUMBER;i++)
  {
    fprintf(flrfp,"          R%d",pcrrate40[i]);
  }
  fprintf(flrfp,"\n");
  fprintf(outputfp," BUFFERSIZE   PCR     CLR     FLR   \n");
  for(j=0;j<NUMBER;j++)
  {
    sprintf(filename,"buffer%d",buffer[j]);
    bufferfp=fopen(filename,"w");
    if(bufferfp==NULL){
      fprintf(stderr,"can not open the file\n");
      exit(1);
    }
    fprintf(clrfp,"B%d",buffer[j]);
    fprintf(flrfp,"B%d",buffer[j]);
    for(k=0;k<PCRNUMBER;k++)
    {
      totalbuffersize=buffer[j];
      freebuffersize=totalbuffersize;
      totalframe=0;
      totalcell=0;
      clr=0;
      flr=0;
      lostcell=0;
      lostframe=0;
      pcr40=pcrrate40[k];
      if(totalbuffersize==6000)
        printf("pcr40 is %d", pcrrate40[k]);
     
  
      for(count=0;count<FRAMENUMBER;count++)
      {
        cellsize=framearray[count];
        totalframe++;
        totalcell+=cellsize;
        /*input a frame*/
        if(freebuffersize<cellsize)
        {
             lostcell+=(cellsize-freebuffersize);
             freebuffersize=0;
             lostframe++;
        }
        else
        {
           freebuffersize-=cellsize;
        }
        freebuffersize+=pcr40;
        if(freebuffersize>totalbuffersize)
           freebuffersize=totalbuffersize;
      }
      clr=(double)lostcell/totalcell;
      flr=(double)lostframe/totalframe;
      clrarray[j][k]=clr;
      flrarray[j][k]=flr;
      pcr=pcr40*25;
      fprintf(bufferfp," %d  %f\n",pcr,clr);
      fprintf(clrfp,"    %f",clr);
      fprintf(flrfp,"    %f",flr);
      fprintf(outputfp," %d  %d  %f  %f\n", totalbuffersize,pcr,clr,flr);
    }
    fprintf(clrfp,"\n");
    fprintf(flrfp,"\n"); 
    fclose(bufferfp);
  }
  fclose(outputfp);
  fclose(clrfp);
  fclose(flrfp);
}     
      
